#
# http://web.mit.edu/kerberos/www/krb5-1.2/krb5-1.2.6/doc/install.html
#

# --------------------------------------------------------------------
# Install the Master KDC
# create master with stash file
export PATH=/sbin:/usr/sbin:$PATH
kdb5_util create -r FJFI.CVUT.CZ -s

# Add Administrators to the Acl File
# viz manual

# Add Administrators to the Kerberos Database
kadmin.local
addprinc admin/admin@FJFI.CVUT.CZ
# Create a kadmind Keytab
ktadd -k /var/kerberos/krb5kdc/kadm5.keytab kadmin/admin kadmin/changepw

# Start the Kerberos Daemons on the Master KDC
/etc/init.d/krb5kdc start
/etc/init.d/kadmin start

# --------------------------------------------------------------------
# Install the Slave KDCs
# Create Host Keys for the Slave KDCs
kadmin
addprinc -randkey host/kerberos.fjfi.cvut.cz
addprinc -randkey host/kerberos-1.fjfi.cvut.cz
addprinc -randkey host/kerberos-2.fjfi.cvut.cz
addprinc -randkey host/kerberos-3.fjfi.cvut.cz
# Extract Host Keytabs for the KDCs
ktadd host/kerberos-1.fjfi.cvut.cz
ktadd host/kerberos-2.fjfi.cvut.cz
ktadd host/kerberos-3.fjfi.cvut.cz
# Set Up the Slave KDCs for Database Propagation
# viz manual

# Replication
# make kpropd.acl on ! slave ! kerberos servers
cat > /var/kerberos/krb5kdc/kpropd.acl << EOT
host/kerberos-1.fjfi.cvut.cz@FJFI.CVUT.CZ
host/kerberos-2.fjfi.cvut.cz@FJFI.CVUT.CZ
host/kerberos-3.fjfi.cvut.cz@FJFI.CVUT.CZ
EOT

# on master type
scp /etc/krb5.keytab kerberos-2.fjfi.cvut.cz:/etc
scp /etc/krb5.keytab kerberos-3.fjfi.cvut.cz:/etc

# propagate krb database to slave KDCs
# you can use script below

# Create Stash Files on the Slave KDCs
kdb5_util stash

# replication from crontab
15 * * * * /usr/local/bin/krb5prop.sh

cat > /usr/local/bin/krb5prop.sh < EOT
#!/bin/sh
slave_kdc="kerberos-2.fjfi.cvut.cz kerberos-3.fjfi.cvut.cz"
/usr/kerberos/sbin/kdb5_util dump /var/kerberos/krb5kdc/slave_datatrans
for i in $slave_kdc; do
/usr/kerberos/sbin/kprop -f /var/kerberos/krb5kdc/slave_datatrans $i > /dev/null
done
EOT

#cat > /etc/inetd.conf << EOT
#krb5_prop stream tcp nowait root /usr/local/sbin/kpropd kpropd
#eklogin   stream tcp nowait root /usr/local/sbin/klogind klogind -k -c -e
#EOT
